/*
 * Copyright 2017 Red Hat, Inc. and/or its affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *       http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package org.uberfire.commons.cluster;

import javax.jms.ConnectionFactory;

import org.junit.runner.RunWith;
import org.mockito.junit.MockitoJUnitRunner;

@RunWith(MockitoJUnitRunner.class)
public class ClusterJMSRemoteServiceTest extends BaseClusterJMSServiceTest {

    @Override
    ClusterService getClusterService(ConnectionFactory factory) {
        System.setProperty(ClusterParameters.APPFORMER_JMS_CONNECTION_MODE,
                           ConnectionMode.REMOTE.toString());

        return new ClusterJMSService() {
            @Override
            ConnectionFactory createRemoteConnectionFactory(String jmsURL,
                                                            String jmsUserName,
                                                            String jmsPassword) {
                return factory;
            }
        };
    }
}